package com.zhongdao.jlr.business.service.impl;

import com.util.Vo;
import com.zhongdao.jlr.business.dao.RoleDao;
import com.zhongdao.jlr.business.service.RoleService;
import com.zhongdao.jlr.business.vo.JLRMenu;
import com.zhongdao.jlr.pojo.BaseMenu;
import com.zhongdao.jlr.pojo.JLRAuthority;
import com.zhongdao.jlr.pojo.JLRRole;
import org.apache.http.util.TextUtils;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Date;
import java.util.List;

/***
 * 处理关于角色的业务
 */
@Service(value = "roleServiceImpl")
public class RoleServiceImpl implements RoleService {

    @Autowired
    RoleDao dao;
//    @Autowired
//    private SessionFactory sessionFactory;

    @Override
    public Vo getRoleInfo(HttpServletRequest request, String name) {
        return dao.getRoleInfo(request,name);
    }

    @Override
    public List<JLRMenu> getTreeInfo() {
        return dao.getTreeInfo();
    }

//    @Override
//    public boolean updateRoleInfo(JLRRole jlrRole, int[] ids) {
//        //获取当前日期
//        Date date=new Date();
//        jlrRole.setUpdate_time(date);
//        jlrRole.setDelete_flag(0);
//        //声明一个角色权限对象
//        JLRAuthority jlrAuthority=new JLRAuthority();
//        if(jlrRole.getId() == null){
//            //随机生成主键id
//            int id=Integer.valueOf((System.currentTimeMillis() / 10 + "").substring(3));
//            jlrRole.setId(id);
//            //将角色id放入对象中
//            jlrAuthority.setRole_id(id);
//        }else{
//            //如果角色id不为空则判断此操作为修改,删除权限信息
//            dao.deleteSupplier(jlrRole.getId());
//            jlrAuthority.setRole_id(jlrRole.getId());
//        }
//        //添加角色信息
//        dao.updateRoleInfo(jlrRole);
//        //将时间放入对象中
//        jlrAuthority.setUpdate_time(date);
//        try {
//        Session session = sessionFactory.getCurrentSession().getSessionFactory().openSession();
//        Transaction tx = session.beginTransaction();
//        //遍历菜单id,并批量添加数据
//        for(int i=0 ; i<ids.length;i++){
//            //将菜单id放入对象中
//            jlrAuthority.setMenu_id(ids[i]);
//            //将时间放入对象中
//            jlrAuthority.setId(Integer.valueOf((System.currentTimeMillis() / 10 + "").substring(3)));
//            //添加
//            System.out.println(i);
//            session.saveOrUpdate(jlrAuthority);
//            System.out.println(i+"---");
//            if (i % 2 == 0)
//
//            {
//                session.flush();
//
//                session.clear();
//
//                tx.commit();
//
//                tx = session.beginTransaction();
//
//            }
//        }
//
//        tx.commit();
//            closeResouce(session);
//        }catch (Exception e){
//            e.printStackTrace();
//            return false;
//        }
//        return true;
//    }

//    /**
//     * 关闭资源
//     *
//     * @param object
//     * @throws Exception
//     */
//    protected void closeResouce(Object object) throws Exception {
//        if (null == object)
//            return;
//
//        if (object instanceof Connection) {
//            Connection conn = (Connection) object;
//            conn.close();
//        } else if (object instanceof Statement) {
//            Statement statement = (Statement) object;
//            statement.close();
//        } else if (object instanceof PreparedStatement) {
//            PreparedStatement prepared = (PreparedStatement) object;
//            prepared.close();
//        } else if (object instanceof ResultSet) {
//            ResultSet rs = (ResultSet) object;
//            rs.close();
//        } else if (object instanceof Session) {
//            Session session = (Session) object;
//            session.close();
//        }
//
//    }


    @Override
    public boolean updateRoleInfo(JLRRole jlrRole, int[] ids) {
        //获取当前日期
        Date date=new Date();
        jlrRole.setUpdate_time(date);
        jlrRole.setDelete_flag(0);
        //声明一个角色权限对象
        JLRAuthority jlrAuthority=new JLRAuthority();
        if(jlrRole.getId() == null){
            //随机生成主键id
            int id=Integer.valueOf((System.currentTimeMillis() / 10 + "").substring(3));
            jlrRole.setId(id);
            //将角色id放入对象中
            jlrAuthority.setRole_id(id);
        }else{
            //如果角色id不为空则判断此操作为修改,删除权限信息
            dao.deleteSupplier(jlrRole.getId());
            jlrAuthority.setRole_id(jlrRole.getId());
        }
        //添加角色信息
        dao.updateRoleInfo(jlrRole);
        //将时间放入对象中
        jlrAuthority.setUpdate_time(date);
        //遍历菜单id,并批量添加数据
        for(int i=0 ; i<ids.length;i++){
            //将菜单id放入对象中
            jlrAuthority.setMenu_id(ids[i]);
            //将时间放入对象中
            jlrAuthority.setId(Integer.valueOf((System.currentTimeMillis() / 10 + "").substring(3)));
            //添加
            boolean state=dao.updateRolesInfo(jlrAuthority);
            if(state == false){
                return false;
            }
        }
        return true;
    }

    @Override
    public JLRRole getRole(String id) {
        return dao.getUser(id);
    }

    @Override
    public List<BaseMenu> getMenu(String id) {
        return dao.getMenu(id);
    }

    @Override
    public boolean deleteRole(String id, String name) {
            //声明一个角色对象
            JLRRole jlrRole = new JLRRole();
            //将数据放入对象中
            jlrRole.setId(Integer.valueOf(id));
            jlrRole.setName(name);
            jlrRole.setDelete_flag(1);
            Date date = new Date();
            jlrRole.setUpdate_time(date);
            //分别删除角色信息和权限信息
            if (dao.updateRoleInfo(jlrRole) && dao.deleteSupplier(jlrRole.getId())) {
                return true;
            }
            return false;
    }
}
